<?php
/*
    This file is part of CSS:Portal.

    Written by Jonathan Levine <jxl180@gmail.com>
    Copyright 2009 Jonathan Levine
    
    CSS:Portal is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    CSS:Portal is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with CSS:Portal.  If not, see <http://www.gnu.org/licenses/>.
	
	The full copy of the GNU General Public License is saved as COPY in CSS:Portal's top directory.
*/

session_start();
require('includes/connect.inc.php');
include("classes/cssource_class.php");
include_once("classes/valve_rcon.php");


if(file_exists('install/'))
{
	die('Once installation is complete, the install directory must be erased from the webserver.');
}
if(!isset($_SESSION['username']))
	header("location:login.php");
if(isset($_POST['submit']))
{
	if($_POST['title']==NULL || $_POST['body']==NULL)
	{
		$empty=1;
	}
	else
	{
		$empty=0;
		$sql="SELECT id FROM cssp_servers ORDER BY id";
		$query=mysql_query($sql);
		$count=mysql_num_rows($query);
		if($count==0)
		{
			$noservers=1;
		}
		else
		{
			$noservers=0;
			if(!isset($_POST['servercheck']))
			{
				$noselection=1;
			}
			if(isset($_POST['servercheck']))
			{
				$count=count($_POST['servercheck']);
				if($count==0)
				{
					$noselection=1;
				}
				else
				{
					$noselection=0;
					$title=stripslashes($_POST['title']);
					$title=strip_tags($title);
					$title=mysql_real_escape_string($title);
					$body=wordwrap($_POST['body'],70,'\n',true);
					$body=addslashes($body);
					$body=strip_tags($body);
					$body=mysql_real_escape_string($body);
					$body=stripslashes($body);
					
					$sql = "INSERT INTO `cssp_news` (`title`, `author`, `body`) VALUES ('$title', '". $_SESSION['username'] ."', '$body');";
					$query=mysql_query($sql);
					$sql = "SELECT * FROM cssp_news ORDER BY ID DESC LIMIT 1";
					$query=mysql_query($sql);
					while($postinfo=mysql_fetch_assoc($query))
					{
						$id=$postinfo['id'];
						$timestamp=$postinfo['date'];
						$author=$postinfo['author'];
					}
					$servercheck=$_POST['servercheck'];
					$countarray=count($servercheck);
					$i=0;
					while($i < $countarray)
					{
						set_time_limit(120);
						$sql="SELECT * FROM cssp_servers WHERE ip='". $servercheck[$i] ."' LIMIT 1";
						$query=mysql_query($sql);
						while($serverinfo=mysql_fetch_array($query))
						{
				$r = new valve_RCON($serverinfo['rcon'],$servercheck[$i],$serverinfo['port'],Valve_RCON::PROTO_SOURCE);
							$r->connect();
							$r->authenticate();
							$localtime=date("h:ia T");
							$r->command('es_set cssp_time "'. $localtime);
							$r->command('es_set cssp_id "'. $id);
							$r->command('es_set cssp_title "'. stripslashes($title));
							$r->command('es_set cssp_author "'. $author);
							$r->command('es_set cssp_body "'. stripslashes($body));
							$r->command('es_doblock cssportal/addnews');
							$r->disconnect();
						}
						$i++;
					}
				}
			}
		}
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta name="Description" content="Information architecture, Web Design, Web Standards." />
<meta name="Keywords" content="your, keywords" />
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<meta name="Distribution" content="Global" />
<meta name="Author" content="Erwin Aligam - ealigam@gmail.com" />
<meta name="Robots" content="index,follow" />
<script type="text/javascript" src="javascripts/prototype.js"></script>
<script type="text/javascript" src="javascripts/scriptaculous.js?load=effects"></script>
<script src="javascripts/scriptaculous.js" type="text/javascript"></script>
<script src="javascripts/modalbox/modalbox.js" type="text/javascript"></script>
<link rel="stylesheet" href="javascripts/modalbox/modalbox.css" type="text/css" media="screen" />
<link rel="stylesheet" href="images/Refresh.css" type="text/css" />

<title>CSS:Portal</title>
</head>

<body>
<!-- wrap starts here -->
<div id="wrap">
		
		<!--header -->
		<div id="header">			
				
			<h1 id="logo-text">CSS<span class="gray">Portal</span></h1>
			<form class="search" method="post" action="#">
				<?php include('includes/livetime.inc.php'); ?>
			</form>			
				
		</div>
		
		<!-- menu -->	
		<div  id="menu">
			<ul>
				<li><a href="index.php">Home</a></li>
				<li id="current"><a href="admin.php">Admin</a></li>
				<li><a href="support.html">Support</a></li>
				<li><a href="http://www.eventscripts.com">Eventscripts</a></li>
				<li><a href="http://forums.eventscripts.com/index.php">ES Forum</a></li>	
			</ul>
		</div>					
			
		<!-- content-wrap starts here -->
		<div id="content-wrap">
				
			<?php include('includes/sidemenu.inc.php'); ?>
				
<div id="main">
				
				<a name="main"></a>
<h1>CSS:Portal</h1>
	
    <form id="form1" method="post" action="announce.php">
				<?php 
                if(isset($empty))
                {
                    if($empty==1)
                        echo '<center><font color="red">All Fields Are Required!</font></center>';
                }
				if(isset($noservers))
                {
                  if($noservers==1)
                   echo '<center><font color="red">You must add at least one server!</font></center>';
                }
				if(isset($noselection))
                {
                  if($noselection==1)
				  {
                echo '<center><font color="red">You must select at least one server!</font></center>';
				  }
				  if($noselection==0)
				  {
                echo '<center><font color="#00FF00">Post Successful!</font></center>';
				  }
                }
                ?>
                  <br /><center><small>Title: </small>
                  <?php
				  if(isset($empty))
				  {
					 if(isset($noservers,$noselection))
					 {
					  if($noservers==1 || $noselection==1|| $empty==1)
					  {
	echo '<input type="text" name="title" id="textfield" value="'. $_POST['title'] .'" /></center>';
					  }
					  else
                  	echo '<input type="text" name="title" id="textfield"/></center>';
					 }
					 else
	echo '<input type="text" name="title" id="textfield" value="'. $_POST['title'] .'" /></center>';
				  }
				  else
                  	echo '<input type="text" name="title" id="textfield"/></center>';
				  ?>
    		  <br />
                   <center>
                   <?php
				  if(isset($empty))
				  {
					 if(isset($noservers,$noselection))
					 {
					  if($noservers==1 || $noselection==1|| $empty==1)
					  {
					  		echo '<textarea name="body" cols="45" rows="5" class="textbox" id="textarea">'. $_POST['body'] .'</textarea>';
					  }
					  else
                  		echo '<textarea name="body" cols="45" rows="5" class="textbox" id="textarea"></textarea>';
					 }
					 else
						 echo '<textarea name="body" cols="45" rows="5" class="textbox" id="textarea">'. $_POST['body'] .'</textarea>';
				  }
				  else
           			echo '<textarea name="body" cols="45" rows="5" class="textbox" id="textarea"></textarea>';
				  ?><small>Try to keep it short. A popup is limited by the number of rows.</small>
                  <br /><br />     
                  <table border="1" cellspacing="0">
                  <?php
				  $sql="SELECT * FROM cssp_servers ORDER BY id";
				  $query=mysql_query($sql);
				  $count=mysql_num_rows($query);
				  if($count==0)
				  {
					echo '<b>No servers have been added.</b>';
					if(isset($_SESSION['id']))
					{
						if($_SESSION['id']==1)
						{
						echo '<b><a href="addserver.php" title="Add Server" onclick="Modalbox.show(this.href, {title: this.title, overlayClose: false, width: \'830\', height: \'100%\', afterHide: function() { window.location.reload()}}); return false;">Add Server</a>.</b>';
						}
					}
				  }
				  else
				  { 
					 echo '<tr>
					 <td>Hostname</td>
					 <td>IP</td>
					 <td>Players</td>';
					 	if(isset($_SESSION['id']))
							{
								if($_SESSION['id']==1)
								{
									echo '<td></td>';
								}
							}
					while($row=mysql_fetch_array($query))
					{
						$css = new cssource($row['ip'], $row['port']);
					 $css->setSortBy("frags"); 
					 $output = $css->status();
					if($css->connerr==0)
						{
						echo '<tr>
		<td><input type="checkbox" name="servercheck[]" value="'. $row['ip'] .'" checked="true" />&nbsp;'. substr($output['hostname'],0,30); if(strlen($output['hostname']) > 30)
			{ echo '...'; } echo '</td>
						<td>'. $row['ip'] .':'. $row['port'] .'</td>
						<td align="center">'. $output['num_players'] .'/'. $output['max_players'] .'</td>';
							if(isset($_SESSION['id']))
							{
								if($_SESSION['id']==1)
								{
									echo '<td><a href="delserver.php?id='. $row['id'] .'" title="Delete Server" onclick="Modalbox.show(this.href, {title: this.title, width: \'830\', height: \'100%\', afterHide: function() { parent.location.href=\'announce.php\'}}); return false;">Delete</a></td>
								</tr>';
								}
							}
						}
						else
						{
							echo '<tr>
							<td>Could not connect to the socket.</td>
							<td>'. $css->ip .':'. $css->port .'</td>';
						if(isset($_SESSION['id']))
					  {
						if($_SESSION['id']==1)
						{
							echo '<td></td>
							<td><a href="delserver.php?id='. $row['id'] .'" title="Delete Server" onclick="Modalbox.show(this.href, {title: this.title, width: \'830\', height: \'100%\', afterHide: function() { parent.location.href=\'announce.php\'}}); return false;">Delete</a></td>
							</tr>';
						}
					  }
						}
					}
				  }
					
					?>
                    </table>
                  <input name="button2" type="reset" class="button" id="button2" value="&lt;&lt; Reset" />
      <input name="submit" type="submit" class="button" id="button" value="Post &gt;&gt;" /></center>
   
    </form>
          

			</div>
		
	    <p>
		      <!-- content-wrap ends here -->	
		      </div>
		      
		      <!--footer starts here-->
</p>
	    <?php include('includes/footer.inc.php'); ?>

<!-- wrap ends here -->
</div>

</body>
</html>
